<?php
session_start();
if (!isset($_SESSION['Auth_OK_Super']) ){
        header('Location: index.php');
        exit();
}

include("common_functions.php");
if ( strpos($_SERVER["REQUEST_METHOD"], "POST") !== false )
{
	$post = true;
}
else
{
	$post = false;
}

$username = $_COOKIE['username'];
$auth_file  = "/opt/MicroWorld/etc/auth.conf";
$runasroot = "/opt/MicroWorld/sbin/runasroot";
$auth_conf = false;
if (file_exists($auth_file))
	$auth_conf = MW_readConf($auth_file,'#',"",'"');

$message = false;
$invalid;
if($_POST['Submit'] == "Create")
{
	$user = trim($_POST['user_name']);
	$new_pass = trim($_POST['new_password']);
	$confirm_pass = trim($_POST['confirm_password']);	
	if(!isvalid_emailid_single1($_POST['user_name']) == 0)
	{
		$invalid['user']=1;
		$message = "Invalid username";	
	}	
	elseif( !preg_match("/^[a-zA-Z0-9\.!@#$%^&*_-]++$/", $new_pass) || !preg_match("/^[a-zA-Z0-9\.!@#$%^&*_-]++$/", $confirm_pass) )
	{
		$invalid['Char_pass']=1;
		$message = "(!&)<>i;'`\"| and spaces are not allowed";
	}
	elseif( strlen($new_pass)<5 || strlen($confirm_pass)<5)
	{
		$invalid['Len_pass']=1;
		$message = "Password should have atleast 5 characters";
        }
	if(count($invalid) == 0){		
		if($_POST['Submit'] == "Create")
		{
			if( strlen(trim($_POST['new_password'])) != 0 && strlen(trim($_POST['confirm_password'])) != 0  && ! is_numeric(trim($_POST['confirm_password']))) //
			{
				if((strcmp($_POST['new_password'],$_POST['confirm_password'])==0))
				{
					$passwd = $_POST["new_password"];
					$message = "Super user created";
				        $superuser=create_user($user,$passwd,"/opt/MicroWorld/etc/passwd","SUPERUSER","1");
				}
				else
				{
					$message = "New password and Re-type new password fields do not match.";
				}
		
			}
			else
			{
				$message = "Blank or Numeric passwords is not allowed";
			}
		}
	}
	if($auth_conf === false)
		$auth_conf = array();
	$auth_conf['auth']['type']=0;
        exec("$runasroot /bin/touch $auth_file");
        exec("$runasroot /bin/chown mwconf:mwconf $auth_file");
	MW_writeConf($auth_conf,$auth_file,"",'"');
}
elseif($_POST['Submit'] == "Test & Save")
{
	$Tldap_server	= trim($_POST['ldap_server']);
	$Tldap_port	= trim($_POST['ldap_port']) + 0;
	$Tbase_dn	= trim($_POST['base_DN']);
	$TuserAttr	= trim($_POST['userAttr']);
	$Tfilter	= trim($_POST['filter']);
	$Tldap_user	= trim($_POST['ldap_user']);
	$Tldap_passwd	= trim($_POST['ldap_password']);
	if(strlen($Tldap_user) == 0)
	{
		$message = "Please provide user name for testing LDAP credential.";
	}
	elseif(strlen($Tldap_passwd) == 0)
	{
		$message = "Please provide password for testing LDAP credential.";
	}
	elseif(MW_isvalid_ip($Tldap_server) !== 0)
	{
		$message = "Invalid ldap server.";
	}
	elseif(!is_numeric($_POST['ldap_port']) || $Tldap_port <= 0 || $Tldap_port >= 65536)
	{
		$message = "Invalid ldap port.";
	}
	elseif(strlen($Tbase_dn) == 0)
	{
		$message = "Invalid empty Base DN";
	}
	elseif(strlen($TuserAttr) == 0)
	{
		MW_status("Invalid user search attribute. Enter proper credential. See note #1 for details below.");
	}
	else
	{
		if(Authenticate_LDAP_User($Tldap_user,$Tldap_passwd,$Tldap_server,$Tldap_port,$Tbase_dn,$TuserAttr,$Tfilter)
		    == true)
		{
			$auth_conf['auth']['type']		= 1;
			$auth_conf['ldapauth1']['server']	= $Tldap_server;
			$auth_conf['ldapauth1']['port']		= $Tldap_port;
			$auth_conf['ldapauth1']['base']		= $Tbase_dn;
			$auth_conf['ldapauth1']['userattr']	= $TuserAttr;
			$auth_conf['ldapauth1']['filter']	= $Tfilter;
			$auth_conf['ldapauth1']['privilege']	= "super";
			$auth_conf['ldapauth1']['enabled']	= "1";

			exec("$runasroot /bin/touch $auth_file");
			exec("$runasroot /bin/chown mwconf:mwconf $auth_file");
			MW_writeConf($auth_conf, $auth_file, "", '"');
			$message = "LDAP Authentication Successful and credentials added successfully.";
		}
		else
		{
			 $message = "LDAP Authentication Failed. Credential can not be saved.<br>Make sure that parameters are correct and LDAP service is running<br>on specified server and port.";
		}
	 }
}


?>
<HTML>
<HEAD>
<TITLE>MicroWorld Create Admin</TITLE>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
<link rel="stylesheet" href="/styles/mwti.css" type="text/css"/>

<script type="text/javascript">

function check_pass_fun()
{
	document.getElementById('LDAP_Auth').style.display = 'none';
	document.getElementById('check_pass').style.display = 'block';
}

function LDAP_Auth_fun()
{
	document.getElementById('check_pass').style.display = 'none';
	document.getElementById('LDAP_Auth').style.display = 'block';
}

</script>

</HEAD>

<BODY onLoad="putFocus(0,0);" marginwidth="0" marginheight="0" bgcolor="#D6E0FC">
<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
  <tr>
    <td background="images/linux_bgtop.jpg">
      <table width="100%" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td width="101"><img src="images/linux_top_banner.jpg" width=209 height=118></td>
          <td align="right" valign="bottom">
            <img src="images/linux_top.gif" width="39" height="46" align="bottom">&nbsp;<br><br>
           </td>
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td height="50" valign="middle" bgcolor="#D6E0FC">
      <table width="100%" border="0" cellspacing="0" cellpadding="0" bgcolor="#D6E0FC">
        <tr>
          <td align="center" valign="middle">
<?php
if($message !== false)
	MW_status($message);
?>
	  </td>
	</tr>
        <tr>
          <td align="center" valign="top">


<form name="myfrm" method="post" action="createadmin.php">
<br>
<center>
<div id="check_pass_BOX" style="width:150px; height:150px; position: absolute; border:1px ; left: 267px;">
<table class="tabledata" width="450" cellspacing="10" align="center">
<tr>
<td width="30%" align="left" colspan='2'><b>Authentication Type</b></td>
</tr>
<tr>
<td width = "10%" align='left'>CheckPass Authentication</td>
<td width = "20%">
<input type="radio" OnChange="SetModified(true);" name="auth_type" value="0" onClick="check_pass_fun(); document.getElementById('show_status').style.display='none'"
<?php if($auth_conf === false || $auth_conf["auth"]["type"]  == "0") echo "checked"?>>
</td>
</tr>
<tr>
<td width = "10%" align='left'>LDAP Authentication</td>
<td width = "20%"><input type="radio" OnChange="SetModified(true);" name="auth_type" value="1" onClick="LDAP_Auth_fun(); document.getElementById('show_status').style.display='none'"
<?php
if(($auth_conf !== false && $auth_conf["auth"]["type"]  == "1") || ($post && $_POST['auth_type'] == '1'))
	echo 'checked';
?>>
</td>
</tr>
</table>

<br>
<div id="LDAP_Auth_Div" style="width:150px; height:150px; position: absolute; border:1px ;right: 1px; ">
<table class="tabledata" width="450" cellspacing="10" align="center" id = "LDAP_Auth">
<tr>
<td align="left" colspan='2'><b>Enter LDAP Credentials</b></td>
<td align="right"><a align="right" href="index.php">Back to login</a></td>
</tr>
<tr title='IP of the user server'>
<td width="10%"></td>
<td width="30%">LDAP Server: </td>
<td><input type="text" name="ldap_server" OnChange="SetModified(true);" class="edit_box" size="20"  value="
<?php
if($post)
	echo $_POST['ldap_server'];
else
	echo "127.0.0.1";
?>"></td>
</tr>
<tr title='Port on which LDAP is running on server'>
<td width="10%"></td>
<td width="30%">LDAP Port: </td>
<td><input type="text" name="ldap_port" OnChange="SetModified(true);" class="edit_box" size="20"  value="
<?php
if($post)
        echo $_POST['ldap_port'];
else
	echo "389";
?>"></td>
</tr>
<tr title='BaseDN of the user'>
<td width="10%"></td>
<td width="30%">BaseDN: </td>
<td><input type="text" name="base_DN" OnChange="SetModified(true);" class="edit_box" size="20"  value="
<?php
if($post)
        echo $_POST['base_DN'];
else
	echo "dc=example,dc=com";
?>"></td>
</tr>
<tr title='username attribute in full DN of user'>
<td width="10%"></td>
<td width="30%">User attribute: </td>
<td><input type="text" name="userAttr" OnChange="SetModified(true);" class="edit_box" size="20"  value="
<?php
if($post)
        echo $_POST['userAttr'];
else
	echo "cn";
?>"><font color='blue'>#1</font></td></td>
</tr>
<tr title='Search filter criteria'>
<td width="10%"></td>
<td width="30%">Filter:</td>
<td><input type="text" name="filter" OnChange="SetModified(true);" class="edit_box" size="20"  value="
<?php
if($post)
        echo $_POST['filter'];
else
	echo "cn=%u";
?>"><font color='blue'>#2</font></td>
</tr>
<tr title='User ID to test the connection'>
<td width="10%"></td>
<td width="30%">Username:</td>
<td>
<input type="text" name="ldap_user" OnChange="SetModified(true);" class="edit_box" size="20"  value=""><font color='blue'>#3</font>
</td>
</tr>
<tr title='User password to test the connection'>
<td width="10%"></td>
<td width="30%">Password:</td>
<td>
<input type="password" name="ldap_password" OnChange="SetModified(true);" class="edit_box" size="20"  value=""><font color='blue'>#3</font>
</td>
</tr>
<tr>
<td align="center" width="88%" colspan='3'>
<input type="submit"  name="Submit" value="Test & Save" onClick="SetSubmitted(true);" title='Click to test and save'>
<input type="reset" value="Reset" onClick="SetModified(false);" title='Reset the fileds with initial values'>
</td>
</tr>
<tr>
<td colspan='3'>
<font color='blue'><b><u>#1</u></b> User attribute is the field of the user DN in which user name will be searched. For example, if user 'Admin' to be authenticated has distiguished name (DN)<br>cn=Admin,ou=webadmin,dc=example,dc=com<br>then, enter the User attribute as<br>cn<br>or, if user 'Admin' to be authenticated has DN<br>uid=Admin,ou=webadmin,dc=example,dc=com<br>then, enter the filter as<br>uid<br>while in both cases, BaseDN must be ou=webadmin,dc=example,dc=com
</td>
</tr>
<tr>
<td colspan='3'>
<font color='blue'><b><u>#2</u></b> Filter field is optional. It is usefull, if you want to allow only the users of specific group(s) should be allowed to login to eScan WebAdmin.<br>Examples<br><b>Example 1</b> If users of "Organisational Unit" sysadmins are to be allowed to login, then use filter as<br>ou=sysadmins<br><b>Example 2</b> If, you want the users of "Organisational Unit" sysadmins or of objectclass managers should be allowed to login then create the filter as<br>(|(ou=sysadmins)(objectclass=managers))<br><b>Example 3</b> To allow the users of "Organisational Unit" sysadmins and of objectclass managers, create the filter as<br>(&(ou=sysadmins)(objectclass=managers))<br><br>If you want the user id to be the part of search criteria, then put %u in place of user name, and that will be replaced with the user id while checking the authentication.<br><b>Example 4</b> If you want to authenticate the user having DN<br>cn=Admin,ou=webadmin,dc=example,dc=com<br>where uid field is Admin, then create filter as<br>uid=%u<br><b>Example 5</b> For above example, if you want to include the filter of ou=sysadmins, then create filter as<br>(&(uid=%u)(ou=sysadmins))<br><b>Example 6</b> For above example, if you want to apply filter like, either uid is 'username' supplied or it belongs to ou=sysadmins, then create filter as<br>(|(uid=%u)(ou=sysadmins))<br><b>Example 7</b> To search the filter for more than 2 criterias like,  uid is 'username' supplied and it belongs either to ou=sysadmins or objectclass=managers, then create filter as<br>(&(uid=%u)(|(ou=sysadmins)(objectclass=managers)))<br><br>Please note that, if you want to search username in any filter criteria, you must apply filter as "{search-attribute}=%u", where %u will be replaced with user name to be authenticated.<br></font>
</td>
</tr>
<tr>
<td colspan='3'>
<font color='blue'><b><u>#3</u></b> Username and password will not be saved. It will be used to test the credential of LDAP configuration before saving the configuration.</font>
</td>
</tr>

</table>
</div>
<div id="check_pass_Div" style="width:150px; height:150px; position: absolute; border:1px ; right: 1px;"> 
<table class="tabledata" width="450" cellspacing="10" align="center" id = "check_pass">
<tr>
<td width="30%" align="left" colspan='2'><b>Create super user</b></td>
<td align="right"><a align="right" href="index.php">Back to login</a></td>
</tr>
<tr>
<td width="10%"></td>
<td width="40%">Username (Email-id): </td>
<td><input type="text" name="user_name" OnChange="SetModified(true);" class="edit_box" size="20"  value="
<?php
if($post)
	echo $_POST['user_name'];
else
        echo $username;
?>"></td>
</tr>
<tr>
<td width="10%"></td>
<td width="40%">Password: </td>
<td><input type="password" name="new_password" OnChange="SetModified(true);" class="edit_box" size="20"></td>
</tr>
<tr>
<td width="10%"></td>
<td width="40%">Re-type password:  </td>
<td><input type="password" name="confirm_password" OnChange="SetModified(true);" class="edit_box" size="20"></td>
</tr>
<tr>
<td align="center" width="88%" colspan='3'>
<input type="submit"  name="Submit" value="Create" onClick="SetSubmitted(true);" >
<input type="reset" value="Reset" onClick="SetModified(false);">
</td>
</tr>
</table>
</div>
</div>
</form>

</td>
</tr>
</table>


</td>
</tr>
</table>
<br>

</body>
<?php
echo "<script type='text/javascript'>";
if(($auth_conf !== false && $auth_conf["auth"]["type"]  == "1") || ($post && $_POST['auth_type'] == '1'))
	echo "LDAP_Auth_fun()";
else
	echo "check_pass_fun()";
echo "</script>";
?>
</html>

