<?php
include("common_functions.php");
// code for detection of javascript and cookie support in client browser

if(strpos($_SERVER["REQUEST_METHOD"],"GET") !== false )
{
	header("Location: index.php");
	exit();
}
$disabled='';
if($_POST["jscript"] == 0 && !isset($_COOKIE['test'] ))
{
	$disabled="javascript and cookies ";
}
elseif($_POST["jscript"] == 0 )
{
        $disabled="javascript";
}
elseif(!isset($_COOKIE['test'])) 
{
	$disabled="cookies";
}
session_start();
$passwdFile="/opt/MicroWorld/etc/passwd";
$product=trim($_POST['product_name']);
$username=trim($_POST['uname']);
$passwd = trim($_POST["pass"]);
$language = $_POST["language"];
$conffile = "/opt/MicroWorld/etc/auth.conf";
$auth_conf = false;
if(file_exists($conffile))
{
	Upgrade_Old_Auth_Conf($conffile);
	$auth_conf = MW_readConf($conffile, "#", '', '"');
}
else
{
	$auth_conf = array();
	$auth_conf['auth']['type'] = 0;
	exec("$runasroot /bin/touch $conffile");
	exec("$runasroot /bin/chown mwconf:mwconf $conffile");
	MW_writeConf($auth_conf,$conffile,"",'"');
}


if ($product == "noselect")
{
	header("Location: index.php?err_msg=product");
	exit();
}
elseif($auth_conf['auth']['type'] == 1)
{
        if(strlen($username) == 0)
	{
		header("Location: index.php?err_msg=user");
		exit();
	}
	elseif( strlen($passwd) == 0)
	{
		header("Location: index.php?err_msg=nopassword");
		exit();
	}
        else
        {
		$auth = false;
		foreach($auth_conf as $confname => $conf)
		{
			if(!preg_match("/^ldapauth[0-9]+$/i", $confname)) continue;
			elseif(isset($conf['enabled']) && $conf['enabled'] == "0") continue;
			elseif(isset($conf['privilege']) && strcasecmp($conf['privilege'], "super") != 0) continue;
			$lserver = $conf['server'];
			$lport = $conf['port'];
			$lbase = $conf['base'];
			$userattr = $conf['userattr'];
			$lfilter = $conf['filter'];
			if(Authenticate_LDAP_User($username, $passwd, $lserver, $lport,$lbase,$userattr,$lfilter) == true)
			{
				$auth = true;
				$_SESSION['SUPER'] = true;
			}
		}
		if(!$auth && $product == "mailscan")
		{
			foreach($auth_conf as $confname => $conf)
			{
				if(!preg_match("/^ldapauth[0-9]+$/i", $confname)) continue;
				elseif(isset($conf['enabled']) && $conf['enabled'] == "0") continue;
				elseif(!isset($conf['privilege']) || strcasecmp($conf['privilege'], "super") ==0) continue;
				$lserver = $conf['server'];
				$lport = $conf['port'];
				$lbase = $conf['base'];
				$userattr = $conf['userattr'];
				$lfilter = $conf['filter'];
				if(Authenticate_LDAP_User($username, $passwd, $lserver, $lport, $lbase, $userattr, $lfilter)
				    == true)
				{
					$auth = true;
					$_SESSION['USERS'] = true;
				}
			}
		}
		if(!$auth)
                {
                         header("Location: index.php?err_msg=permission_denied");
                         exit();
                }
        }
}
elseif($auth_conf['auth']['type'] == 0)
{
	if(isvalid_emailid_single1($username) != 0 )
	{
		header("Location: index.php?err_msg=user");
		exit();
	}
	elseif( strlen($passwd) < 5)
	{
		header("Location: index.php?err_msg=password_len");
		exit();
	}
	else
	{
		$retval = check_user($username, "NULL", $passwdFile, "NULL");
		//echo $retval;
		list($k,$v)=explode("-",$retval);
		if($v != 0 )
		{
			header("Location: index.php?err_msg=usernotexists");
			exit();
		}
		elseif( strlen($passwd)<5 )
		{
			header("Location: index.php?err_msg=password_len");
	        	exit();
		}
		elseif( !preg_match("/^[a-zA-Z0-9\.!@#$%^&*_-]++$/", $passwd) )
		{
			header("Location: index.php?err_msg=password_chars");
			exit();
		}
		else
		{
	  		$retval=check_user($username,$passwd,$passwdFile,"USERS");
			list($k,$v)=explode("-",$retval);
			if($v == 0)
			{
	   			$retval=check_user($username,$passwd,$passwdFile,$product);
				list($k,$v)=explode("-",$retval);
				if($v == 0)
				{
	    				list($type,$temp)=split(" ",$k);
					//session variable for type of user admin/superuser
					$_SESSION[$type]= true;
				}
				else
				{	//echo "sharif -user ::$retval";
					if($product == "mailscan")
					{
						$_SESSION["USERS"]=true;
					}
					else
					{
						header("Location: index.php?err_msg=permission_denied");
						exit();
					}
	   			}
			}
			else
			{
	   			header("Location: index.php?err_msg=password");
				exit();
			}
		}
	}
}	
setcookie("username",$username);
setcookie("product",$product);
setcookie("language",$language);
setcookie("authtype",$auth_conf['auth']['type']);
if($_POST["rememberme"] == 1)
{
	setcookie("rememberme","rememberme");
}
else
{
	setcookie("rememberme","");
}

if ($product == "mwav")
{
	$_SESSION['Auth_OK'] = true;
	header("Location: valid_key.php");
	exit();
}
else
{
	$_SESSION['Auth_OK'] = true;
	header("Location: valid_key.php");
	exit();
}

if($disabled)
{
	echo "
		<HTML>
		<HEAD>
		<TITLE>eScan WebAdmin</TITLE>
		<META HTTP-EQUIV='Content-Type' CONTENT='text/html; charset=iso-8859-1'>
		<link rel='stylesheet' href='/styles/mwti.css' type='text/css'>
		</HEAD>

		<BODY bgcolor='#D6E0FC' leftmargin='0' topmargin='0' marginwidth='0' marginheight='0'>
		<table width='100%' border='0' cellspacing='0' cellpadding='0' align='center'>
		  <tr> 
		    <td background='/images/linux_bgtop.jpg'>
		      <table width='100%' border='0' cellspacing='0' cellpadding='0'>
			<tr>
			  <td width='101'><img src='/images/linux_top_banner.jpg' width=209 height=118></td>
			  <td align='right' valign='bottom'>
			    <img src='/images/linux_top.gif' width='39' height='46' align='bottom'>
			    <br>
			    <br>
			  </td>
			</tr>
		      </table>
		    </td>
		  </tr>
		  <tr> 
		    <td height='100' colspan='4'>&nbsp;</td>
		  </tr>
		  <tr> 
		    <td height='200' valign='top' align='right' bgcolor='#D6E0FC' width='48%'>
		      <table width='100%' border='0' cellspacing='0' cellpadding='0'>
			<tr> 
			  <td align='right' valign='top'>
				<table class='tabledata' align='center' width='520' cellspacing='5'>
					<tr>
						<td align='center' >
							<font color='#FF0000'>Your browser does not support $disabled, please enable the $disabled and login again.</font>
						</td>
					</tr>
					<tr>
						<td align='center'>
						</td>
					</tr>
				</table>
			  </td>
			</tr>
			<tr> 
			  <td align='center'>
			    <br>
			    <form method='post' Action='index.php'>
			      <input type='submit' name='submit' value='Back'>
			    </form>
			  </td>
			</tr>
		      </table>
		    </td>
		  </tr>
		</table>

		</BODY>
		</HTML>
	";
}


?>
